<?php

namespace Drupal\weather_api_plugin;

use Drupal\Component\Plugin\PluginBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Base class for WeatherApiPlugin.
 */
abstract class WeatherApiPluginBase extends PluginBase implements WeatherApiPluginInterface {

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function getConfiguration() {
    return $this->configuration;
  }

  /**
   * {@inheritdoc}
   */
  public function setConfiguration(array $configuration) {
    $this->configuration = $configuration;
    $configFactory = \Drupal::getContainer()->get('config.factory')->getEditable('weather_api_plugin.weather_service');
    $configFactory->set($this->getServiceId(), $this->configuration)->save();
  }

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    return $form = [];
  }

  /**
   * {@inheritdoc}
   */
  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {}

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {}

  /**
   * {@inheritDoc}
   */
  public function getBuildTemplate() {
    return $this->pluginDefinition['template'];
  }

  /**
   * {@inheritDoc}
   */
  public function getBaseUrl() {
    return $this->pluginDefinition['base_url'];
  }

  /**
   * {@inheritDoc}
   */
  public function getPluginLabel() {
    return isset($this->pluginDefinition['overridden_label']) ? $this->pluginDefinition['overridden_label'] : $this->pluginDefinition['label'];
  }

  /**
   * {@inheritdoc}
   */
  public function getServiceId() {
    return $this->pluginDefinition['id'];
  }

}
